'use strict';

var STR_MAP = {
  'true': true,
  'false': false,
  'null': null,
  'nan': NaN,
  'infinity': Infinity,
  'undefined': undefined
};

function jsonParseTransform(key, value) {
  if (key === '__proto__' || key === 'prototype' || key === 'constructor') {
    return;
  }

  return value;
}

function destr(val) {
  if (typeof val !== 'string') {
    return val;
  }

  var _lval = val.toLowerCase();

  if (_lval in STR_MAP) {
    // @ts-ignore
    return STR_MAP[_lval];
  }

  if (val[0] !== '"' && val[0] !== '{' && val[0] !== '[') {
    return val;
  }

  return JSON.parse(val, jsonParseTransform);
}

module.exports = destr;
